iniparser: src/iniparser.h File Reference

iniparser 4.2.2

Loading...
Searching...
No Matches
Functions
iniparser.h File Reference

Parser for ini files. More...

`#include "dictionary.h"`
`#include <stdint.h>`

Go to the source code of this file.

## Functions
void | iniparser_set_error_callback (int(*errback)(const char *,...))
| Configure a function to receive the error messages.
int | iniparser_getnsec (const dictionary *d)
| Get number of sections in a dictionary.
const char * | iniparser_getsecname (const dictionary *d, int n)
| Get name for section n in a dictionary.
void | iniparser_dump_ini (const dictionary *d, FILE *f)
| Save a dictionary to a loadable ini file.
void | iniparser_dumpsection_ini (const dictionary *d, const char *s, FILE *f)
| Save a dictionary section to a loadable ini file.
void | iniparser_dump (const dictionary *d, FILE *f)
| Dump a dictionary to an opened file pointer.
int | iniparser_getsecnkeys (const dictionary *d, const char *s)
| Get the number of keys in a section of a dictionary.
const char ** | iniparser_getseckeys (const dictionary *d, const char *s, const char **keys)
| Get the number of keys in a section of a dictionary.
const char * | iniparser_getstring (const dictionary *d, const char *key, const char *def)
| Get the string associated to a key.
int | iniparser_getint (const dictionary *d, const char *key, int notfound)
| Get the string associated to a key, convert to an int.
long int | iniparser_getlongint (const dictionary *d, const char *key, long int notfound)
| Get the string associated to a key, convert to an long int.
int64_t | iniparser_getint64 (const dictionary *d, const char *key, int64_t notfound)
| Get the string associated to a key, convert to an int64_t.
uint64_t | iniparser_getuint64 (const dictionary *d, const char *key, uint64_t notfound)
| Get the string associated to a key, convert to an uint64_t.
double | iniparser_getdouble (const dictionary *d, const char *key, double notfound)
| Get the string associated to a key, convert to a double.
int | iniparser_getboolean (const dictionary *d, const char *key, int notfound)
| Get the string associated to a key, convert to a boolean.
int | iniparser_set (dictionary *ini, const char *entry, const char *val)
| Set an entry in a dictionary.
void | iniparser_unset (dictionary *ini, const char *entry)
| Delete an entry in a dictionary.
int | iniparser_find_entry (const dictionary *ini, const char *entry)
| Finds out if a given entry exists in a dictionary.
dictionary * | iniparser_load (const char *ininame)
| Parse an ini file and return an allocated dictionary object.
dictionary * | iniparser_load_file (FILE *in, const char *ininame)
| Parse an ini file and return an allocated dictionary object.
void | iniparser_freedict (dictionary *d)
| Free all memory associated to an ini dictionary.

## Detailed Description

Parser for ini files.

Author
  N. Devillard

## Function Documentation

## ◆ iniparser_dump()

void iniparser_dump | ( | const dictionary * | d,
|  | FILE * | f )

Dump a dictionary to an opened file pointer.

Parameters

  d | Dictionary to dump.
  f | Opened file pointer to dump to.

This function prints out the contents of a dictionary, one element by line, onto the provided file pointer. It is OK to specify `stderr` or `stdout` as output files. This function is meant for debugging purposes mostly.

## ◆ iniparser_dump_ini()

void iniparser_dump_ini | ( | const dictionary * | d,
|  | FILE * | f )

Save a dictionary to a loadable ini file.

Parameters

  d | Dictionary to dump
  f | Opened file pointer to dump to

This function dumps a given dictionary into a loadable ini file. It is Ok to specify `stderr` or `stdout` as output files.

All values are quoted, these charecters are escaped:

- ' : the quote character (e.g. "String with \"Quotes\"")
- \ : the backslash character (e.g. "C:\\tmp")

## ◆ iniparser_dumpsection_ini()

void iniparser_dumpsection_ini | ( | const dictionary * | d,
|  | const char * | s,
|  | FILE * | f )

Save a dictionary section to a loadable ini file.

Parameters

  d | Dictionary to dump
  s | Section name of dictionary to dump
  f | Opened file pointer to dump to

This function dumps a given section of a given dictionary into a loadable ini file. It is Ok to specify `stderr` or `stdout` as output files.

## ◆ iniparser_find_entry()

int iniparser_find_entry | ( | const dictionary * | ini,
|  | const char * | entry )

Finds out if a given entry exists in a dictionary.

Parameters

  ini | Dictionary to search
  entry | Name of the entry to look for

Returns
  integer 1 if entry exists, 0 otherwise

Finds out if a given entry exists in the dictionary. Since sections are stored as keys with NULL associated values, this is the only way of querying for the presence of sections in a dictionary.

## ◆ iniparser_freedict()

void iniparser_freedict | ( | dictionary * | d | ) |

Free all memory associated to an ini dictionary.

Parameters

  d | Dictionary to free

Free all memory associated to an ini dictionary. It is mandatory to call this function before the dictionary object gets out of the current context.

## ◆ iniparser_getboolean()

int iniparser_getboolean | ( | const dictionary * | d,
|  | const char * | key,
|  | int | notfound )

Get the string associated to a key, convert to a boolean.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  integer

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

A true boolean is found if one of the following is matched:

- A string starting with 'y'
- A string starting with 'Y'
- A string starting with 't'
- A string starting with 'T'
- A string starting with '1'

A false boolean is found if one of the following is matched:

- A string starting with 'n'
- A string starting with 'N'
- A string starting with 'f'
- A string starting with 'F'
- A string starting with '0'

The notfound value returned if no boolean is identified, does not necessarily have to be 0 or 1.

## ◆ iniparser_getdouble()

double iniparser_getdouble | ( | const dictionary * | d,
|  | const char * | key,
|  | double | notfound )

Get the string associated to a key, convert to a double.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  double

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

## ◆ iniparser_getint()

int iniparser_getint | ( | const dictionary * | d,
|  | const char * | key,
|  | int | notfound )

Get the string associated to a key, convert to an int.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  integer

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

Supported values for integers include the usual C notation so decimal, octal (starting with 0) and hexadecimal (starting with 0x) are supported. Examples:

- "42" -> 42
- "042" -> 34 (octal -> decimal)
- "0x42" -> 66 (hexa -> decimal)

Warning: the conversion may overflow in various ways. Conversion is totally outsourced to strtol(), see the associated man page for overflow handling.

Credits: Thanks to A. Becker for suggesting strtol()

## ◆ iniparser_getint64()

int64_t iniparser_getint64 | ( | const dictionary * | d,
|  | const char * | key,
|  | int64_t | notfound )

Get the string associated to a key, convert to an int64_t.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  integer

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

Supported values for integers include the usual C notation so decimal, octal (starting with 0) and hexadecimal (starting with 0x) are supported. Examples:

- "42" -> 42
- "042" -> 34 (octal -> decimal)
- "0x42" -> 66 (hexa -> decimal)

Warning: the conversion may overflow in various ways. Conversion is totally outsourced to strtoimax(), see the associated man page for overflow handling.

This function is usefull on 32bit architectures where `long int` is only 32bit.

## ◆ iniparser_getlongint()

long int iniparser_getlongint | ( | const dictionary * | d,
|  | const char * | key,
|  | long int | notfound )

Get the string associated to a key, convert to an long int.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  integer

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

Supported values for integers include the usual C notation so decimal, octal (starting with 0) and hexadecimal (starting with 0x) are supported. Examples:

- "42" -> 42
- "042" -> 34 (octal -> decimal)
- "0x42" -> 66 (hexa -> decimal)

Warning: the conversion may overflow in various ways. Conversion is totally outsourced to strtol(), see the associated man page for overflow handling.

## ◆ iniparser_getnsec()

int iniparser_getnsec | ( | const dictionary * | d | ) |

Get number of sections in a dictionary.

Parameters

  d | Dictionary to examine

Returns
  int Number of sections found in dictionary

This function returns the number of sections found in a dictionary. The test to recognize sections is done on the string stored in the dictionary: a section name is given as "section" whereas a key is stored as "section:key", thus the test looks for entries that do not contain a colon.

This clearly fails in the case a section name contains a colon, but this should simply be avoided.

This function returns -1 in case of error.

## ◆ iniparser_getseckeys()

const char ** iniparser_getseckeys | ( | const dictionary * | d,
|  | const char * | s,
|  | const char ** | keys )

Get the number of keys in a section of a dictionary.

Parameters

  d | Dictionary to examine
  s | Section name of dictionary to examine
  keys | Already allocated array to store the keys in

Returns
  The pointer passed as `keys` argument or NULL in case of error

This function queries a dictionary and finds all keys in a given section. The keys argument should be an array of pointers which size has been determined by calling `iniparser_getsecnkeys` function prior to this one.

Each pointer in the returned char pointer-to-pointer is pointing to a string allocated in the dictionary; do not free or modify them.

## ◆ iniparser_getsecname()

const char * iniparser_getsecname | ( | const dictionary * | d,
|  | int | n )

Get name for section n in a dictionary.

Parameters

  d | Dictionary to examine
  n | Section number (from 0 to nsec-1).

Returns
  Pointer to char string

This function locates the n-th section in a dictionary and returns its name as a pointer to a string statically allocated inside the dictionary. Do not free or modify the returned string!

This function returns NULL in case of error.

## ◆ iniparser_getsecnkeys()

int iniparser_getsecnkeys | ( | const dictionary * | d,
|  | const char * | s )

Get the number of keys in a section of a dictionary.

Parameters

  d | Dictionary to examine
  s | Section name of dictionary to examine

Returns
  Number of keys in section

## ◆ iniparser_getstring()

const char * iniparser_getstring | ( | const dictionary * | d,
|  | const char * | key,
|  | const char * | def )

Get the string associated to a key.

Parameters

  d | Dictionary to search
  key | Key string to look for
  def | Default value to return if key not found.

Returns
  pointer to statically allocated character string

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the pointer passed as 'def' is returned. The returned char pointer is pointing to a string allocated in the dictionary, do not free or modify it.

## ◆ iniparser_getuint64()

uint64_t iniparser_getuint64 | ( | const dictionary * | d,
|  | const char * | key,
|  | uint64_t | notfound )

Get the string associated to a key, convert to an uint64_t.

Parameters

  d | Dictionary to search
  key | Key string to look for
  notfound | Value to return in case of error

Returns
  integer

This function queries a dictionary for a key. A key as read from an ini file is given as "section:key". If the key cannot be found, the notfound value is returned.

Supported values for integers include the usual C notation so decimal, octal (starting with 0) and hexadecimal (starting with 0x) are supported. Examples:

- "42" -> 42
- "042" -> 34 (octal -> decimal)
- "0x42" -> 66 (hexa -> decimal)

Warning: the conversion may overflow in various ways. Conversion is totally outsourced to strtoumax(), see the associated man page for overflow handling.

This function is usefull on 32bit architectures where `long int` is only 32bit.

## ◆ iniparser_load()

dictionary * iniparser_load | ( | const char * | ininame | ) |

Parse an ini file and return an allocated dictionary object.

Parameters

  ininame | Name of the ini file to read.

Returns
  Pointer to newly allocated dictionary

This is the parser for ini files. This function is called, providing the name of the file to be read. It returns a dictionary object that should not be accessed directly, but through accessor functions instead.

Iff the value is a quoted string it supports some escape sequences:

- " or ' : the quote character (e.g. 'String with "Quotes"' or "String with 'Quotes'")
- \ : the backslash character (e.g. "C:\tmp")

Escape sequences always start with a backslash. Additional escape sequences might be added in the future. Backslash characters must be escaped. Any other sequence then those outlined above is invalid and may lead to unpredictable results.

The returned dictionary must be freed using iniparser_freedict().

## ◆ iniparser_load_file()

dictionary * iniparser_load_file | ( | FILE * | in,
|  | const char * | ininame )

Parse an ini file and return an allocated dictionary object.

Parameters

  in | File to read.
  ininame | Name of the ini file to read (only used for nicer error messages)

Returns
  Pointer to newly allocated dictionary

This is the parser for ini files. This function is called, providing the file to be read. It returns a dictionary object that should not be accessed directly, but through accessor functions instead.

Iff the value is a quoted string it supports some escape sequences:

- " or ' : the quote character (e.g. 'String with "Quotes"' or "String with 'Quotes'")
- \ : the backslash character (e.g. "C:\tmp")

Escape sequences always start with a backslash. Additional escape sequences might be added in the future. Backslash characters must be escaped. Any other sequence then those outlined above is invalid and may lead to unpredictable results.

The returned dictionary must be freed using iniparser_freedict().

## ◆ iniparser_set()

int iniparser_set | ( | dictionary * | ini,
|  | const char * | entry,
|  | const char * | val )

Set an entry in a dictionary.

Parameters

  ini | Dictionary to modify.
  entry | Entry to modify (entry name)
  val | New value to associate to the entry.

Returns
  int 0 if Ok, -1 otherwise.

If the given entry can be found in the dictionary, it is modified to contain the provided value. If it cannot be found, the entry is created. It is Ok to set val to NULL.

## ◆ iniparser_set_error_callback()

void iniparser_set_error_callback | ( | int(*)(const char *,...) | errback | ) |

Configure a function to receive the error messages.

Parameters

  errback | Function to call.

By default, the error will be printed on stderr. If a null pointer is passed as errback the error callback will be switched back to default.

## ◆ iniparser_unset()

void iniparser_unset | ( | dictionary * | ini,
|  | const char * | entry )

Delete an entry in a dictionary.

Parameters

  ini | Dictionary to modify
  entry | Entry to delete (entry name)

If the given entry can be found, it is deleted from the dictionary.